% ######################
% global_vars a renseigner
% ######################


% ######################
% on touche plus
% ######################

if strcmp('PCWIN', computer)
	system('dir /O-D /AD /B .');
else
	system('ls -t .');
end

nom_fichier = input('\nFichier de vitesse contenant l etat de base a representer: ', 's');


% on determine le type de codage (little-endian, big-endian) en regardant l'en-tete du fichier

% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(nom_fichier, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(nom_fichier, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end


% on lit toutes les metadonnees
FID = fopen(nom_fichier, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
NX              = fread(FID, 1, 'integer*4');
NY              = fread(FID, 1, 'integer*4');
NZ              = fread(FID, 1, 'integer*4');
LX              = fread(FID, 1, 'real*8');
LY              = fread(FID, 1, 'real*8');
LZ              = fread(FID, 1, 'real*8');
dt              = fread(FID, 1, 'real*8');
truncate        = fread(FID, 1, 'integer*4');
type_trunc      = fread(FID, 1, 'integer*4');
rtrunc_x        = fread(FID, 1, 'real*8');
rtrunc_y        = fread(FID, 1, 'real*8');
rtrunc_z        = fread(FID, 1, 'real*8');
nu              = fread(FID, 1, 'real*8');
stratification  = fread(FID, 1, 'integer*4');
xns             = fread(FID, 1, 'real*8');
schm            = fread(FID, 1, 'real*8');
omega2          = fread(FID, 1, 'real*8');
perturb        = fread(FID, 1, 'integer*4');
lin             = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');


% instant de l'enregistrement
poub            = fread(FID, 1, 'integer*4');
instant         = fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');


% on lit toutes les valeurs des differents champs
poub = fread(FID, 1, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');

poub = fread(FID, NX*NY*NZ, 'real*8');
poub = fread(FID, 2, 'integer*4');


VBX = fread(FID, NX*NY, 'real*8');
VBY = fread(FID, NX*NY, 'real*8');
VBZ = fread(FID, NX*NY, 'real*8');
poub = fread(FID, 2, 'integer*4');
WBX = fread(FID, NX*NY, 'real*8');
WBY = fread(FID, NX*NY, 'real*8');
WBZ = fread(FID, NX*NY, 'real*8');
status = fclose(FID);

% on reordonne les tableaux
VBX = reshape(VBX, [NX,NY]);
VBY = reshape(VBY, [NX,NY]);
VBZ = reshape(VBZ, [NX,NY]);
WBX = reshape(WBX, [NX,NY]);
WBY = reshape(WBY, [NX,NY]);
WBZ = reshape(WBZ, [NX,NY]);


% on affiche quelques informations sur la simulation
fprintf(1, '\n Dimensions du probleme: %i * %i * %i \n', NX, NY, NZ);
fprintf(1, '\n Dimensions physiques de la boite: %f * %f * %f \n', LX, LY, LZ);
fprintf(1, '\n Stratification: %i , %f \n', stratification, xns);

% on cre la grille des points de colocation dans l'espace physique
X = linspace(0, LX-LX/NX, NX);
Y = linspace(0, LY-LY/NY, NY);
Z = linspace(0, LZ-LZ/NZ, NZ);


% Vbx
subplot(2,2,1);

contour(X,Y,VBX',20);
title('Vbx');
xlabel('x');
ylabel('y');
axis square;
colorbar;

% Vby
subplot(2,2,2);

contour(X,Y,VBY',20);
title('Vby');
xlabel('x');
ylabel('y');
axis square;
colorbar;

% Wbz
subplot(2,2,3);

contour(X,Y,WBZ',20);
title('Wbz');
xlabel('x');
ylabel('y');
axis square;
colorbar;

subplot(2,2,4);
plot(Y,WBZ(1,:));
title('Wbz');
xlabel('y');
ylabel('Wbz');
