% Ce script lit un fichier de sortie genere par le code ns3d du type "velo_rho_vort_t=****.***"
% et en extrait un champ de vitesse et de vorticite.
% Il ecrit ensuite un fichier de base 2D permettant de faire une simulation lineaire.
% On peut eventuellement ajouter une vitesse uniforme de translation suivant la direction x.

% commandes qu'il peut etre utile d'utiliser auparavant...
% awk '/of ut/ {print $4}' listing.txt > estimation_ut
% awk '/on ut/ {print $7}' listing.txt > estimation_error_ut

% A = load('estimation_ut');
% B = load('estimation_error_ut');




% ######################
% on touche plus
% ######################


if strcmp('PCWIN', computer)
	ls('.');
else
	system(['ls -t ', '.']);
end

fichier = input('fichier de vitesse specifique: ', 's');
ut = input('Vitesse suivant x a ajouter (0 si pas d ajout) : ');

% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(fichier, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(fichier, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end

% on lit toutes les metadonnees
FID = fopen(fichier, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
nz              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
lz              = fread(FID, 1, 'real*8');
dt              = fread(FID, 1, 'real*8');
truncate        = fread(FID, 1, 'integer*4');
type_trunc      = fread(FID, 1, 'integer*4');
rtrunc_x        = fread(FID, 1, 'real*8');
rtrunc_y        = fread(FID, 1, 'real*8');
rtrunc_z        = fread(FID, 1, 'real*8');
nu              = fread(FID, 1, 'real*8');
stratification  = fread(FID, 1, 'integer*4');
xns             = fread(FID, 1, 'real*8');
schm            = fread(FID, 1, 'real*8');
omega2          = fread(FID, 1, 'real*8');
perturb         = fread(FID, 1, 'integer*4');
lin             = fread(FID, 1, 'integer*4');
poub            = fread(FID, 1, 'integer*4');
status = fclose(FID);

% on affiche quelques informations sur la simulation
fprintf(1, 'Dimensions du probleme: %i * %i * %i \n', nx, ny, nz);
fprintf(1, 'Dimensions physiques de la boite: %f * %f * %f \n', lx, ly, lz);
if stratification
	fprintf(1, 'Stratification: %f \n\n', xns);
else
  fprintf(1, 'Stratification: non \n\n', xns);
end

nz_choix = input('indice de la coupe suivant la direction z : ');


FID = fopen(fichier, 'r',type_endian);

% on lit toutes les metadonnees d'un coup "comme si" c'tait des entiers de 4 octets mme si ce n'est pas vrai,
% l'important est que le nombre d'octets soit respecte

poub = fread(FID, 33, 'integer*4');

poub = fread(FID, 1, 'integer*4');
instant = fread(FID, 1, 'real*8');
poub = fread(FID, 2, 'integer*4');
Velo_X = fread(FID, nx*ny*nz, 'real*8');
poub = fread(FID, 2, 'integer*4');
Velo_Y = fread(FID, nx*ny*nz, 'real*8');
poub = fread(FID, 2, 'integer*4');
Velo_Z = fread(FID, nx*ny*nz, 'real*8');
poub = fread(FID, 2, 'integer*4');
Rho = fread(FID, nx*ny*nz, 'real*8');
poub = fread(FID, 2, 'integer*4');
Vort_X = fread(FID, nx*ny*nz, 'real*8');
poub = fread(FID, 2, 'integer*4');
Vort_Y = fread(FID, nx*ny*nz, 'real*8');
poub = fread(FID, 2, 'integer*4');
Vort_Z = fread(FID, nx*ny*nz, 'real*8');

status = fclose(FID);

Velo_X = reshape(Velo_X, [nx,ny,nz]);
Velo_Y = reshape(Velo_Y, [nx,ny,nz]);
Velo_Z = reshape(Velo_Z, [nx,ny,nz]);
Rho    = reshape(Rho,    [nx,ny,nz]);
Vort_X = reshape(Vort_X, [nx,ny,nz]);
Vort_Y = reshape(Vort_Y, [nx,ny,nz]);
Vort_Z = reshape(Vort_Z, [nx,ny,nz]);


% on ajoute eventuellement une vitesse de translation suivant x
if ut
	Velo_X(:,:,nz_choix) =  Velo_X(:,:,nz_choix) + ut;
end


% on ajoute un mouvement de rotation solide (utile lorsque la vorticite moyenne
% est artificiellement mise a 0 par les FFT...
%fprintf(1, '\nAjout rotation solide avec comme vorticite verticale... %f \n', 2*2*pi/(lx*ly));
%Vort_Z(:,:,nz_choix) =  Vort_Z(:,:,nz_choix) + 2*2*pi/(lx*ly);
%Xcentre = linspace(0, lx-lx/nx, nx)-lx/2;
%Ycentre = linspace(0, ly-ly/ny, ny)-ly/2;
%Velo_X(:,:,nz_choix) =  Velo_X(:,:,nz_choix) - 2*pi/(lx*ly)*ones(nx,1)*Ycentre;
%Velo_Y(:,:,nz_choix) =  Velo_Y(:,:,nz_choix) + 2*pi/(lx*ly)*Xcentre'*ones(1,ny);

% on effectue eventuellement une translation des champs selon les axes x et y
% pour determiner la translation necessaire pour centrer un tourbillon
% on peut utiliser les commandes suivantes pour determiner l'indice de son max de vorticite :
[valeur,I] = max(Vort_Z(:,:,nz_choix));
[valeur,ind_ymax] = max(max(Vort_Z(:,:,nz_choix)));
ind_xmax = I(ind_ymax);

fprintf(1, '\nIndex on x of the maximum of vertical vorticity: %i \n', ind_xmax);
fprintf(1, '\nIndex on y of the maximum of vertical vorticity: %i \n', ind_ymax);

trans_x = input('Translation suivant x a ajouter (0 si pas d ajout) : ');
trans_y = input('Translation suivant y a ajouter (0 si pas d ajout) : ');

if trans_x | trans_y
	Velo_X(:,:,nz_choix) =  circshift(Velo_X(:,:,nz_choix),[trans_x trans_y]);
    Velo_Y(:,:,nz_choix) =  circshift(Velo_Y(:,:,nz_choix),[trans_x trans_y]);
    Velo_Z(:,:,nz_choix) =  circshift(Velo_Z(:,:,nz_choix),[trans_x trans_y]);

    Vort_X(:,:,nz_choix) =  circshift(Vort_X(:,:,nz_choix),[trans_x trans_y]);
    Vort_Y(:,:,nz_choix) =  circshift(Vort_Y(:,:,nz_choix),[trans_x trans_y]);
    Vort_Z(:,:,nz_choix) =  circshift(Vort_Z(:,:,nz_choix),[trans_x trans_y]);
end


% et au format big-endian
FID = fopen(['base2D_', num2str(nx), 'x', num2str(ny), '_L=', num2str(lx), 'x', num2str(ly),'_be'], 'w','ieee-be');

fwrite(FID, 28, 'integer*4');
fwrite(FID, 1, 'integer*4');
fwrite(FID, nx, 'integer*4');
fwrite(FID, ny, 'integer*4');
fwrite(FID, lx, 'real*8');
fwrite(FID, ly, 'real*8');
fwrite(FID, 28, 'integer*4');

fwrite(FID, nx*ny*8*3, 'integer*4');
fwrite(FID, Velo_X(:,:,nz_choix), 'real*8');
fwrite(FID, Velo_Y(:,:,nz_choix), 'real*8');
fwrite(FID, Velo_Z(:,:,nz_choix), 'real*8');
fwrite(FID, nx*ny*8*3, 'integer*4');

fwrite(FID, nx*ny*8*3, 'integer*4');
fwrite(FID, Vort_X(:,:,nz_choix), 'real*8');
fwrite(FID, Vort_Y(:,:,nz_choix), 'real*8');
fwrite(FID, Vort_Z(:,:,nz_choix), 'real*8');
fwrite(FID, nx*ny*8*3, 'integer*4');

status = fclose(FID);


%% We display the final base state
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);
Z = linspace(0, lz-lz/nz, nz);

figure(1)
pcolor(X,Y,squeeze(Vort_Z(:,:,nz_choix))');
axis equal tight   
shading interp
lighting phong
colorbar
xlabel('x');
ylabel('y');
title('Vorticite verticale base state');
