% ce script permet de lire les resultats de la determination de R
% dans chacune des couches horizontales

% type de graphique que l'on veut tracer
type_graphique=2



%%%%%%%%%%%%%%%%%%%%%
% On ne touche plus
%%%%%%%%%%%%%%%%%%%%%

if strcmp('PCWIN', computer)
	ls('.');
else
	system(['ls -t ', '.']);
end

file_name = input('R field file to use: ', 's');


% on commence par essayer en little-endian (PC)
type_endian = 'ieee-le';
FID = fopen(file_name, 'r',type_endian);
poub = fread(FID, 1, 'integer*4');
flag = fread(FID, 1, 'integer*4');
status = fclose(FID);

% si le flag est different de 1, on essaye le big-endian (SGI, NEC, IBM)
if flag ~= 1
    type_endian = 'ieee-be';
    FID = fopen(file_name, 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    flag = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    % on verifie que le flag vaut bien 1 cette fois-ci
    if flag ~= 1
        fprintf(1, '\n Il y a un probleme dans le format du fichier : le flag est different de 1\n');
        return
    end
end

% on lit toutes les metadonnees
FID = fopen(file_name, 'r',type_endian);

poub            = fread(FID, 1, 'integer*4');
flag            = fread(FID, 1, 'integer*4');
nx              = fread(FID, 1, 'integer*4');
ny              = fread(FID, 1, 'integer*4');
nz              = fread(FID, 1, 'integer*4');
lx              = fread(FID, 1, 'real*8');
ly              = fread(FID, 1, 'real*8');
lz              = fread(FID, 1, 'real*8');
nu              = fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');

poub            = fread(FID, 1, 'integer*4');
instant         = fread(FID, 1, 'real*8');
poub            = fread(FID, 1, 'integer*4');

status = fclose(FID);

% on cre la grille des points de colocation
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);
Z = linspace(0, lz-lz/nz, nz);


% on demande quel plan representer
iz = floor(input('\nPlan de coupe: '));

% on lit les donnees correspondant au plan choisi
FID = fopen(file_name, 'r',type_endian);
fseek(FID,(4+4*4+4*8+4) + (4+8+4) + 4 + 8*(iz-1)*nx*ny, 'bof');
R_iz = fread(FID, nx*ny, 'real*8');
status = fclose(FID);

R_iz = reshape(R_iz, [nx,ny]);


figure
if type_graphique==1
    contour(X,Y,R_iz',20);
    colorbar;
else
    pcolor(X,Y,R_iz');
    colorbar;
    shading flat;
end

xlabel('x');
ylabel('y');
axis square;
title(['R  t=', num2str(instant)],'Interpreter','none');


% on lit toutes les donnees
FID = fopen(file_name, 'r',type_endian);
fseek(FID,(4+4*4+4*8+4) + (4+8+4) + 4, 'bof');
R_full  = fread(FID, nx*ny*nz, 'real*8');
status = fclose(FID);

