# we indicate where the velocity files are stores on gaya
dir_save="/home/kelvin/NS3D_results/Fh1.33_Re6000/ns3d_contrarotating_384x384x96_L=2.1x2.1x0.57_Dt=0.0025_nu=0.0001_N=12._brodie_13-12-06_23h25_pid12836/stride_128x128x96"

# dimensions of the velocity files and the strides along each directions
nx=128
ny=128
nz=96

# which field we want to extract? (vx=1,vy=2,vz=3,rho=4,wx=5,wy=6,wz=7)
type_field=4


#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nTemp directory: $dir_save\n"

cp rawdata.F90 $dir_save
cd $dir_save

# we change the dimensions in the source file
sed -e "s/integer, parameter :: nx=.*/integer, parameter :: nx=$nx/" \
    -e "s/integer, parameter :: ny=.*/integer, parameter :: ny=$ny/" \
    -e "s/integer, parameter :: nz=.*/integer, parameter :: nz=$nz/" \
    -e "s/integer :: type_field=.*/integer :: type_field=$type_field/" \
    rawdata.F90 > rawdata.F90_bis

mv rawdata.F90_bis rawdata.F90

# compilation
printf "\nCompilation of the Fortran code...\n"
ifort -O3 rawdata.F90 -o rawdata.out -convert big_endian -assume byterecl -integer_size 64
chmod 744 rawdata.out

# we get the list of the original velocity files
printf "\nGetting the list of the original files...\n"
ls -1 velo_rho_vort.t=* > liste_fichiers.txt

# Copy of each file...
printf "\nCopy of the files and creating rawdata...\n"
mkdir -p rawdata_${nx}x${ny}x${nz}
for name in `cat liste_fichiers.txt`; do
	echo $name | ./rawdata.out;
	mv *.raw rawdata_${nx}x${ny}x${nz}/ ;
done

mv rawdata.F90 rawdata.out liste_fichiers.txt rawdata_${nx}x${ny}x${nz}

exit
