#!/bin/sh

# we indicate where the velocity files are stored
dir_save="/toon/usr/deloncle/NS3D_results/contrarotating/ns3d_contrarotating_512x512x64_L=4.2x4.2x0.57_Dt=0.005_nu=0.0003_N=12._brodie_30-09-06_12h28_pid25982/stride_128x128x32"

# dimensions of the velocity files
nx=128
ny=128
nz=32


#____________________________________________________________
#
#     DO NOT MODIFY BELOW!
#____________________________________________________________
#

printf "\nDirectory: $dir_save\n"

cp timing.F90 elsunc.f90 char_vortices_minpack.F90 minpack.f $dir_save

cd $dir_save

# we change the dimensions in the source file
sed -e "s/integer, parameter :: nx=.*/integer, parameter :: nx=$nx/" \
    -e "s/integer, parameter :: ny=.*/integer, parameter :: ny=$ny/" \
    -e "s/integer, parameter :: nz=.*/integer, parameter :: nz=$nz/" \
    char_vortices_minpack.F90 > char_vortices_minpack.F90_bis

mv char_vortices_minpack.F90_bis char_vortices_minpack.F90

# compilation
printf "\nCompilation of the Fortran code...\n"
ifort -O3 timing.F90 minpack.f char_vortices_minpack.F90 -o char_vortices_minpack -convert big_endian
chmod 744 char_vortices_minpack

# we print the list of the original velocity files
ls -1 velo_rho_vort.t=000[1,2,3]* > liste_fichiers

echo "liste_fichiers" | ./char_vortices_minpack

rm -rf char_vortices_minpack *.mod

exit
