% ######################
% global_vars a renseigner
% ######################

% base directory
dir_base ='.';

% choice of what we plot
%   1) the global mode at the last instant
%   2) the mode at all the instants
%   3) we plot the mode at the specific instants indicated below
mode_affichage = 2;

% choice of plotting matlab function
%   1) function contour. Nice but long for complicated plot.
%   2) function pcolor. Quick but rough.
type_graphique = 2;

% number of plots per figure
subplot_par_figure = [3,4];

nx = 128;
ny = 126;
nz = 126;
lx = 2*pi;
ly = 2*pi;
lz = 2*pi/4;

nxp = nx+2
nyp = ny+1
nzp = nz+1

% ######################
% on touche plus
% ######################

fprintf(1, '\nBase directory: %s\n\n', dir_base);

if strcmp('PCWIN', computer)
	system(['dir /O-D /AD /B ', dir_base]);
else
	system(['ls -t ', dir_base]);
end

dir_spec = input('\nSpecific directory: ', 's');

dir_complet = [dir_base,'/',dir_spec,'/'];


% noms des fichiers de donnees
if strcmp('PCWIN', computer)
	[poub,liste_fichiers] = system(['dir /B "', dir_complet, '"']);
else
	[poub,liste_fichiers] = system(['ls ', dir_complet]);
end

[start,finish] = regexpi(liste_fichiers,'vort.t=\d*\.\d*');

nb_fichiers = size(start,2);

clear nom_fichier
for i=1:nb_fichiers
    nom_fichier(i,:) = liste_fichiers(start(i):finish(i));
end

nom_fichier = sortrows(nom_fichier);
fichier = nom_fichier(1,:)

% we determine the type of binary data (little-endian, big-endian) with the file header

% we start with little-endian (PC)
type_endian = 'ieee-le';

% we display some informations about the simulation
fprintf(1, '\n Dimensions of the simulation: %i * %i * %i \n', nx, ny, nz);
fprintf(1, '\n Physical dimensions of the box: %f * %f * %f \n', lx, ly, lz);

% on cre la grille des points de colocation
X = linspace(0, lx-lx/nx, nx);
Y = linspace(0, ly-ly/ny, ny);
Z = linspace(0, lz-lz/nz, nz);

% on determine selon quel plan reprsente le champ vectoriel 3D
NX_plot = 1;
NY_plot = 1;
NZ_plot = 1;

if mode_affichage==1

    % on lit les donnees dans le dernier fichier enregistre
    FID = fopen([dir_complet,'/',nom_fichier(nb_fichiers,:)], 'r',type_endian);
    poub = fread(FID, 1, 'integer*4');
    temp_x = fread(FID, nxp*nyp*nzp, 'real*8');
    temp_y = fread(FID, nxp*nyp*nzp, 'real*8');
    temp_z = fread(FID, nxp*nyp*nzp, 'real*8');
    poub = fread(FID, 1, 'integer*4');
    status = fclose(FID);

    temp_x = reshape(temp_x, [nxp,nyp,nzp]);
    temp_y = reshape(temp_y, [nxp,nyp,nzp]);
    temp_z = reshape(temp_z, [nxp,nyp,nzp]);
    
    Vort_X = temp_x(1:nx,1:ny,1:nz);
    Vort_Y = temp_y(1:nx,1:ny,1:nz);
    Vort_Z = temp_z(1:nx,1:ny,1:nz);

    figure
    if type_graphique==1
        contour(X,Y,squeeze(Vort_Z(:,:,NZ_plot))',20);
        colorbar;
    else
        pcolor(X,Y,squeeze(Vort_Z(:,:,NZ_plot))');
        shading flat,
    end

    xlabel('x');
    ylabel('y');
    axis square;
    title({['Vorticite verticale']; ['Nb_points=', num2str(nx), 'x', num2str(ny), 'x', num2str(nz), '  L=', num2str(lx), 'x', num2str(ly), 'x', num2str(lz)]},'Interpreter','none');

elseif mode_affichage==2

    % we plot the different statistics
    nb_graphiques = nb_fichiers;

    Nb_plot_par_figure = subplot_par_figure(1)*subplot_par_figure(2);
    nb_figure = ceil(nb_graphiques/Nb_plot_par_figure)

    for ind_figure = 1:nb_figure
    %for ind_figure = 1:1
        figure

       for it=(ind_figure-1)*Nb_plot_par_figure+1:min(ind_figure*Nb_plot_par_figure, nb_graphiques)
       
       %for it=1:1
            subplot(subplot_par_figure(1), subplot_par_figure(2), it - (ind_figure-1)*Nb_plot_par_figure );

            % on lit les donnees dans le dernier fichier enregistre
            FID = fopen([dir_complet,'/',nom_fichier(it,:)], 'r',type_endian);
            
            poub = fread(FID, 1, 'integer*4');
            temp_x = fread(FID, nxp*nyp*nzp, 'real*8');
            temp_y = fread(FID, nxp*nyp*nzp, 'real*8');
            temp_z = fread(FID, nxp*nyp*nzp, 'real*8');
            poub = fread(FID, 1, 'integer*4');
            status = fclose(FID);
        
            temp_x = reshape(temp_x, [nxp,nyp,nzp]);
            temp_y = reshape(temp_y, [nxp,nyp,nzp]);
            temp_z = reshape(temp_z, [nxp,nyp,nzp]);
            
            Vort_X = temp_x(1:nx,1:ny,1:nz);
            Vort_Y = temp_y(1:nx,1:ny,1:nz);
            Vort_Z = temp_z(1:nx,1:ny,1:nz);

            if type_graphique==1
                contour(X,Y,squeeze(Vort_Z(:,:,NZ_plot))',20);
                colorbar;
            else
                pcolor(X,Y,squeeze(Vort_Z(:,:,NZ_plot))');
                % pcolor(X,Z,squeeze(Vort_Z(:,ny/2,:))');
                shading flat,
            end

            xlabel('x');
            ylabel('y');
            axis square;
            title({['Vorticite verticale']; ['Nb_points=', num2str(nx), 'x', num2str(ny), 'x', num2str(nz), '  L=', num2str(lx), 'x', num2str(ly), 'x', num2str(lz)]},'Interpreter','none');

        end
    end
end
