! *******************************************
!    NS3D: extended compilation parameters
! *******************************************

! This file is used by the pre-processor during the compilation step after "config.h".
! It offers extended options not present in the "basic" config.h file. It can be useful
! to overload compilation macros defined in the Makefile, to use other compilation
! parameters less used or to perform tests.

! Avoid multiple inclusions of this file
#ifndef EXTENDED_CONFIG_H
#define EXTENDED_CONFIG_H


! Activation of debug mode
! #define DEBUG


#ifdef MPI

#define IKX ik2
#define IKY ik3
#define IKZ ik1

#else

#define IKX ik1
#define IKY ik2
#define IKZ ik3

#endif


! we insure the right z dimensions when simulating a single kz mode
#ifdef SINGLE_MODE

#undef DIMZ
#define DIMZ 1

#undef PPADKZ
#define PPADKZ 0

#endif

#endif
